/*
 Arduino Projekt 4: HC-SR04 Ultraschallsensor + 1 LED:
 Dieser Sketch funktioniert mit folgender Verkabelung:
 VCC zu Arduino 5v 
 GND zu Arduino GND
 Trig zu Arduino Pin 13
 Echo zu Arduino Pin 12
 LEDPin zu Arduino Pin 11
 
 Sketch basierend auf folgendem Tutorial http://arduinobasics.blogspot.de/2012/11/arduinobasics-hc-sr04-ultrasonic-sensor.html von ScottC
 */


#define echoPin 13 // Echo Pin
#define trigPin 12 // Trigger Pin
#define LEDPin 11 // Pin der LED

int maximumRange = 200; // Maximale Reichweite
int minimumRange = 10; // Minimale Reichweite
long duration, distance; // Dauer zum Berechnen der Reichweite

void setup() {
 Serial.begin (9600); // Im Serialmonitor die Baudrate auf 9600 einstellen
 pinMode(trigPin, OUTPUT); // Pins werden deklariert
 pinMode(echoPin, INPUT);
 pinMode(LEDPin, OUTPUT);
}

void loop() {
// TrigPin/echoPin Zyklus zum Berechnen der Entfernung 
 digitalWrite(trigPin, LOW); 
 delayMicroseconds(2); 

 digitalWrite(trigPin, HIGH);
 delayMicroseconds(10); 
 
 digitalWrite(trigPin, LOW);
 duration = pulseIn(echoPin, HIGH);
 
 //Formel zum Berechnen der Entfernung basierend auf der Schallgeschwindigkeit
 distance = duration/58.2;
 
 if (distance >= maximumRange || distance <= minimumRange){
  // Signalisiert "außer Reichweite" indem -1 an den Computer ausgegeben wird und die LED aufleuchtet
 Serial.println("-1");
 digitalWrite(LEDPin, HIGH); 
 }
 else {
 // Sendet die gemessene Distanz an den Computer und schaltet die LED aus
 Serial.println(distance);
 digitalWrite(LEDPin, LOW); 
 }
 
 //Verzögerung von 50 ms vor dem nächsten Auslesen.
 delay(50);
}
